/***********************************************************************/
/*                                                                     */
/*  FILE        :Kunci_Digital.c                                       */
/*  DATE        :Fri, Sep 15, 2006                                     */
/*  DESCRIPTION :Main Program                                          */
/*  CPU TYPE    :Other                                                 */
/*                                                                     */
/*  This file is generated by Renesas Project Generator (Ver.4.0).     */
/*                                                                     */
/***********************************************************************/
                  
#include "LCDM.h"

const unsigned char msg1[] = "Password: ";
const unsigned char msg2[] = "Benar";
const unsigned char msg3[] = "Salah";

const unsigned char Logic_Tbl[12] = {0x7c,0x7a,0x76,0xbc,0xba,0xb6,
								 0xdc,0xda,0xd6,0xec,0xea,0xe6};
const unsigned char Char_Tbl[]  = "123456789*0#";
const unsigned char CPassword[] = "234";

unsigned char VPassword[2];

void Atur_sfr(){
	p3 		= 0xff;
	pd3		= 0x0f;
	p1		= 0xfe;
	pd1		= 0x01;
	prcr	= 4;
	pd0		= 0xf1;
	prcr	= 0;
}

void AturClock_Ext(){
	asm("FCLR I");				/* Nonaktifkan Interrupt*/
	prc0 = 1;					/* Write protect dimatikan */
	cm13 = 1;					/* P46 dan P47 sebagai Xin-Xout */
	cm15 = 1;					/* Kapasitas drive Xin-Xout dipilih HIGH*/
	cm05 = 0;					/* Aktifkan clock utama */
	cm16 = 0;					/* frkuensi clock tanpa pembagian*/
	cm17 = 0;					/* frkuensi clock tanpa pembagian*/	
	cm06 = 0;					/* CM16 dan CM17 enable */
	asm("nop");
	asm("nop");
	asm("nop");
	asm("nop");
	ocd2 = 0;					/* Dipilih clock utama (dari crystal) */
	prc0 = 0;					/* Write protect diaktifkan */	
}

void Delay_Bounch(void){
	unsigned int i, j;
	for (i=0;i<7;i++)
		for (j=0;j<50000;j++);
}

unsigned char Baca_Tbl(void){
	unsigned char temp, i;
	_Bool Ketemu = 0;
	p1_0 = 0;
	temp = p1 & 0xfe;
	if (temp != 0xfe){
		Ketemu = 0;
		i = 0;
		while ((!Ketemu) && (i<12)){
			if (temp == Logic_Tbl[i]) {
				Ketemu = 1;
				Delay_Bounch();
			}
			else i++;
		}	
	}
	if (Ketemu) return (Char_Tbl[i]);
	else return(0); 
}

_Bool Cek_Password(void){
	unsigned char i;
	_Bool Validitas = 1;
	for (i=0;i<3;i++){
		if (VPassword[i] != CPassword[i])  Validitas = 0;
	}
	return (Validitas);
}

void main(void){
	unsigned char i, temp;
	AturClock_Ext();
	Atur_sfr();
	Init_LCD();
	while(1){
		Baris1();
		KirimPesan_LCD(msg1);
		i = 0;
		while(i<3){
			temp = Baca_Tbl();
			if (temp != 0) {
				VPassword[i] = temp;
				Kirim_Karakter(temp);
				i++;
			}
		}
		Baris2();
		if (Cek_Password()) KirimPesan_LCD(msg2);
		else KirimPesan_LCD(msg3);
		while (Baca_Tbl() != '#');
		Clrscr();
	}	
}
