#ifndef _lcdM
#define _lcdM

#include    <stdio.h>
#include 	"sfr_r813.h"
#include	"string.h"

#define	RS		p3_0
#define E		p3_1

void Delay(unsigned int time);
void OutLCD_Byte(unsigned char x);
void OutLCD_Hex(unsigned char x);                
void Init_LCD(void);
void Kirim_Perintah(unsigned char x);
void Kirim_Karakter(unsigned char x);
void KirimData_LCD(unsigned char x);
void Baris1(void);
void Baris2(void);
void GeserDisplay_Kanan(void);
void GeserDisplay_Kiri(void);
void GeserCursor_Kiri(void);
void GeserCursor_Kanan(void);
void Clrscr(void);
void KirimPesan_LCD(unsigned char* m);


/* Rutin-rutin LCD*/
void OutLCD_Byte(unsigned char x){
	Kirim_Karakter((x/100) + '0');
	Kirim_Karakter(((x%100)/10) + '0');
	Kirim_Karakter(((x%100)%10) + '0');
}

void OutLCD_Hex(unsigned char x){
	unsigned char temp;
	temp = (x & 0xf0) >> 4;
	if (temp < 10) temp = temp + '0';
	else temp = temp + '7';
	Kirim_Karakter(temp);
	temp = x & 0x0f;
	if (temp < 10) temp = temp + '0';
	else temp = temp + '7';
	Kirim_Karakter(temp);
}

void KirimData_LCD(unsigned char x){
	p0  = p0 & 0x0f;
    p0  = p0 | x;
	E	= 1;
	Delay(100);
	E	= 0;
}

void Kirim_Perintah(unsigned char x){
	RS	= 0;
	KirimData_LCD(x);
	x	= x << 4;
	KirimData_LCD(x);
	Delay(1000); 
}

void Kirim_Karakter(unsigned char x){
	RS	= 1;
	KirimData_LCD(x);
	x	= x << 4;
	KirimData_LCD(x);
	Delay(1000);
}

void Init_LCD(){
	E 	= 0;
	RS	= 0;
	KirimData_LCD(0x30); Delay(1000);
	KirimData_LCD(0x30); Delay(1000);
	KirimData_LCD(0x30); Delay(1000);
	KirimData_LCD(0x20); Delay(1000);
    Kirim_Perintah(0x28); Delay(1000);
    Kirim_Perintah(0x06); Delay(1000);
    Kirim_Perintah(0x0e); Delay(1000);
    Kirim_Perintah(0x01); Delay(1000);
    Kirim_Perintah(0x80); Delay(1000);
}

void Baris1(void){
    Kirim_Perintah(0x02);
}

void Baris2(void){
    Kirim_Perintah(0xc0);
}

void GeserDisplay_Kanan(void){
    Kirim_Perintah(0x1f);
}

void GeserDisplay_Kiri(void){
    Kirim_Perintah(0x18);
}

void GeserCursor_Kiri(void){
    Kirim_Perintah(0x10);
}

void GeserCursor_Kanan(void){
    Kirim_Perintah(0x14);
}

void Clrscr(void){
	Kirim_Perintah(0x01);
}

void KirimPesan_LCD(unsigned char* m){
    unsigned char i;
    for (i = 0; i < strlen(m); i++) Kirim_Karakter(m[i]);
}

void Delay(unsigned int time){
	while(time--);
}
/*End of Rutin-rutin LCD*/

#endif